MODULE String_mod

    IMPLICIT NONE
    PUBLIC

CONTAINS

    PURE FUNCTION getLowerCase(string) RESULT(output)
        ! convert string to lower-case
        CHARACTER(*), intent(in)    :: string
        INTEGER, PARAMETER          :: DUC = ICHAR('A') - ICHAR('a')
        CHARACTER(LEN(string))      :: output
        CHARACTER                   :: ch
        INTEGER                     :: i
        DO i = 1,len(string)
            ch = string(i:i)
            IF (ch>='A' .and. ch<='Z') ch = CHAR(ICHAR(ch)-DUC)
            output(i:i) = ch
        END DO
    END FUNCTION getLowerCase

    PURE FUNCTION getUpperCase(string) RESULT(output)
        ! convert string to upper-case
        CHARACTER(*), INTENT(in)    :: string
        INTEGER, PARAMETER          :: DUC = ICHAR('A') - ICHAR('a')
        CHARACTER(LEN(string))      :: output
        CHARACTER                   :: ch
        INTEGER                     :: i
        DO i = 1,LEN(string)
            ch = string(i:i)
            IF (ch>='a' .and. ch<='z') ch = CHAR(ICHAR(ch)+DUC)
            output(i:i) = ch
        END DO
    END FUNCTION getUpperCase

END MODULE String_mod